// C Header File
// Created 07/07/2004; 18:00:07

// Cos and Sin
#define NBDIR 256 // num of dir available for rotation (must be a power of 2 <= 256)
#define SINCOS 4 // precision of cos and sin calculus (the higher the less coords you can see on the map)
// 2^SINCOS must be less or equals to : 2^15 / ((the max size of the longest side of the map (ex:45)) * (height of tiles) * 2^ZOOM)
// SINCOS must be <= 7

// Maps
#define ENABLE_LARGE_MAPS 2 // 0: disabled , 1: enabled, 2: ultra large maps with less memory use
#if ENABLE_LARGE_MAPS == 2
	#define ENABLE_COMPRESSED_MAPS 1 // 0: no compression, 1 maps compressed and need uncompressing when loading
	#define TILES_SIZE 16 // Size in pixels of the side of the tiles used for maps
	#define TILES_SHIFT 4 // 2^TILES_SHIFT = TILES_SIZE
	#define FORCE_MAP_WITDH_TO_1024 1 // 0 : uses variable width, 1 : force to 1024
#endif

// View
#define ZOOM 1	// map zoom = 2^ZOOM (Must be positive)

// Display
#define ENABLE_MORE_DISPLAY 1 // 0: disabled , 1: enabled, launches the function initialized with m7_InitMoreDisplay just after the real display 

// Memory Management
#define DEV_PHASE 0 // 0: not in development phase (release), 1: get message if there is not enough *_MAX_*
#define NB_EXIT_HANDLES 5 // You may want to exit the application and let the memory manager to free NB_EXIT_HANDLES handles for you
#define INTERRUPT_MAX_HANDLERS 7
#define MEMORY_MAX_HANDLES 26
#define MEMORY_MSG "There is not enough free RAM. Please archive every file and uninstall FlashApps if necessary. F-ZERO needs approximately all the 200k RAM\nYou don't need to reset your calculator, everything has been intercepted"

// Link 
#define ENABLE_LINK 1 // 0: disabled , 1: enabled

// Misc
#define ASM_DRAWFRAME 1 // 0: disabled , 1: enabled (experimental) use assembly version of m7_DrawFrame function
#define GAME_SPEED 8 // 0: the fastest
#define ENABLE_GRAYSCALE 1 // 0: disabled , 1: enabled, mode7 in 4 grayscale
#if ENABLE_GRAYSCALE == 1
	#define AUTO_INT_5_GRAYSCALE 1 // 0: grayscale in AI1 (default), 1: in AI5 (allows big modification functions without flickering (InitExit() must be called at the beginnig of the program))
#endif

// debug
#define SHOW_FPS 0 // 0: do not show, 1: show

#include "target.h"

// RES
#if RES == 1
  #include "spritesss.h"
  #include "screen80x25.h"
  #include "skyss.h"
#elif RES == 2
  #include "spritesss.h"
  #include "screen80x50xR.h"
  #include "skyss.h"
#elif RES == 3
  #include "spritescs.h"
  #include "screen88x25.h"
  #include "skycs.h"
#elif RES == 4
  #include "spritescs.h"
  #include "screen88x50xR.h"
  #include "skycs.h"
#endif
