// C Source File
// Created 30/04/2005; 18:42:39

#include <tigcclib.h>

/*
Header :

	"TrackName" // null terminated string max 20 (not including null char)
	"TrackComment" // null terminated string max 20 (not including null char)
	[MapNum] // 1 short : map number
	[MapStyle] // 1 short
	[NbLaps] // 1 short
	[Gravity] // 1 short
	[Direction] // 1 short : direction for start

// map numbers are given for the same data pack as the one containing this track file
*/

const unsigned char * styles[] =
{
	"mutecity",
	"bigblue",
	"porttown",
	"whitland",
	"sndocean",
	"silence",
	"deathwnd",
	"redcanyn",
	"firfield"
};


// Main Function
void _main(void)
{
	FILE * fic;
	ESI argptr;
	unsigned short a;

  InitArgPtr (argptr);
	// file name
	if (GetArgType (argptr) != STR_TAG) {
		DlgMessage("USAGE","STR :filename, STR:trackname, STR:comment, INT:mapnum, STR:style, INT:nblaps, INT:gravity, INT:direction",BT_OK,BT_NONE);
		DlgMessage("STYLES",	"mutecity\nbigblue\nporttown\nwhitland\nsndocean\nsilence\ndeathwnd\nredcanyn\nfirfield",BT_OK,BT_NONE);
		DlgMessage("DIRECTION",	"0: UP\n1: RIGHT\n2: DOWN\n3: LEFT\n",BT_OK,BT_NONE);
		return;
	}
	if ((fic = fopen (GetStrnArg (argptr), "w+b")) == NULL)
		return;
	// track name
	if (GetArgType (argptr) != STR_TAG)
		goto error;
	fputs (GetStrnArg (argptr), fic);	fputc (0, fic);
	// track comment
	if (GetArgType (argptr) != STR_TAG)
		goto error;
	fputs (GetStrnArg (argptr), fic);	fputc (0, fic);
	// map num
	if (GetArgType (argptr) != POSINT_TAG)
		goto error;
	a = GetIntArg (argptr);
	fwrite (&a, sizeof(short), 1, fic);


	// map style
	char style[9];
	if (GetArgType (argptr) != STR_TAG)
		goto error;
	strncpy (style, GetStrnArg (argptr), 8);
	style[8] = 0;
	for(a=0;a<9;a++)
		if(!strcmp(style,styles[a])) break;
	if(a==9) goto error;
	fwrite (&a, sizeof(short), 1, fic);

	// nb laps
	if (GetArgType (argptr) != POSINT_TAG)
		goto error;
	a = GetIntArg (argptr);
	fwrite (&a, sizeof(short), 1, fic);

	// gravity
	if (GetArgType (argptr) != POSINT_TAG)
		goto error;
	a = GetIntArg (argptr);
	fwrite (&a, sizeof(short), 1, fic);

	// direction
	if (GetArgType (argptr) != POSINT_TAG)
		goto error;
	a = GetIntArg (argptr);
	fwrite (&a, sizeof(short), 1, fic);
	
	
	fputc (0, fic);
	fputs ("TRK", fic);
	fputc (0, fic);
	fputc (OTH_TAG, fic);
error:
	fclose (fic);

	
	/////////
}
