// C Source File
// Created 28/07/2004; 17:18:59

#include "game.h"

INT_HANDLER AI6;
INT_HANDLER AI1;

static volatile unsigned char Off = 0;

DEFINE_INT_HANDLER(ON){
  ExecuteHandler(AI6);
  pokeIO(0x600003, 0xFF);
	if(!peekIO_bit (0x60001A, 1) && !Off) Off = 1; // [ON] is pressed
}

DEFINE_INT_HANDLER(OFF){
  ExecuteHandler(AI1);
	if(Off) {
		SetIntVector (AUTO_INT_5, DUMMY_HANDLER);
		off(),Off = 0;
		ReSetIntVector (AUTO_INT_5);
	}
}

unsigned char * scr;
#define ENDING_MESSAGE "F-ZERO for TI68k by Lionel Anton"

void exitFunc(void) {
	LCD_restore(scr);
	ST_helpMsg(ENDING_MESSAGE);
}

LCD_BUFFER scrdata;

// Main Function
void _main(void) {
	LCD_save (scrdata);
	scr = scrdata;
	InitExit ();
	SetExitFunc(exitFunc);

	AI6 = SetIntVector (AUTO_INT_6, ON);

	// inits
	fzeropk0 = afopen (SYMSTR("fzeropk0"));
	fzeropk1 = afopen (SYMSTR("fzeropk1"));
	fzeropk2 = afopen (SYMSTR("fzeropk2"));
	fzerodt0 = afopen (SYMSTR("fzerodt0"));
	if (!(fzeropk0&&fzeropk1&&fzeropk2&&fzerodt0)) {
		char missingfiles[134];
		sprintf(missingfiles, "Missing/unarchived Files :\n%s%s%s%s\n\nPlease transmit and archive all of them in main directory",
			fzeropk0?"":"\n\x12 fzeropk0",
			fzeropk1?"":"\n\x12 fzeropk1",
			fzeropk2?"":"\n\x12 fzeropk2",
			fzerodt0?"":"\n\x12 fzerodt0");
		DlgMessage("FILES",	missingfiles, BT_OK,BT_NONE);
		Exit(0);
	}

	ARCH * version;
	if(!(version = aopen(fzeropk0,"version"))) goto version_error;
	if(*(short*)(version->apos) != DATA_FILE_VERSION) goto version_error;
	aclose(version);
	if(!(version = aopen(fzeropk1,"version"))) goto version_error;
	if(*(short*)(version->apos) != DATA_FILE_VERSION) goto version_error;
	aclose(version);
	if(!(version = aopen(fzeropk2,"version"))) goto version_error;
	if(*(short*)(version->apos) != DATA_FILE_VERSION) goto version_error;
	aclose(version);
	if(!(version = aopen(fzerodt0,"version"))) goto version_error;
	if(*(short*)(version->apos) != DATA_FILE_VERSION) goto version_error;
	aclose(version);
	goto version_ok;
	version_error:
	DlgMessage("FILES",	"Wrong data files version detected", BT_OK,BT_NONE);
	Exit(0);
	version_ok:
	GKeyFlush();
	kbd_Init();
	AI1 = SetIntVector (AUTO_INT_1, OFF);
	m7_Init(9, 60, 20);
	m7_GrayInit();
	m7sprites_Init();

	game();
	GKeyFlush();

	Exit(0);
}
