// C Source File
// Created 28/08/2004; 12:03:32

#include "game.h"

#define NB_BORDER_TILES 60

#define BLANC(x,y) (WM(x,y) == 0xFFFF || !WM(x,y))
#define WM(x,y) WPM[x + (y)*dimX]
#define MAP(x,y) map[x + (y)*dimX]
						
#define NBNODES 10


static unsigned short pass, mod;
static short dimX, dimY;

static inline void put4Nb(short x,short y) {
	if(x>=0 && x<dimX && y>=0 && y<dimY) {
		if(!WM(x,y)) {
			short a = BLANC(x-1,y-1);
			short b = BLANC(x,y-1);
			short c = BLANC(x+1,y-1);
			short d = BLANC(x-1,y);
			short e = BLANC(x+1,y);
			short f = BLANC(x-1,y+1);
			short g = BLANC(x,y+1);
			short h = BLANC(x+1,y+1);
			if (!(((a||b||c)&&(f||g||h)&&(!d)&&(!e)) ||
					 ((a||d||f)&&(c||e||h)&&(!b)&&(!g)) ||
					 ((a)&&(!b)&&(!d)&&(c||e||f||g||h)) ||
					 ((c)&&(!b)&&(!e)&&(a||d||f||g||h)) ||
					 ((f)&&(!d)&&(!g)&&(a||b||c||e||h)) ||
					 ((h)&&(!e)&&(!g)&&(a||b||c||d||f)))) {
				WM(x,y) = pass-1;
				mod = 1;
			/*	DrawPix (x, y, A_NORMAL);*/
			}
		}
	}
}

void setWayPoints(void) {
	short i,j;
	unsigned char * map;
	pass = 0xFFFE;
	unsigned short a,b,c,d,e,f,g,h;
	char updown, leftright;

	unsigned char routex[3];
	unsigned char routey[3];

	typedef struct Node {
		unsigned char x;
		unsigned char y;
		unsigned char routex[3];
		unsigned char routey[3];
		unsigned char routes[3];
	} Node;

	Node * nodes[NBNODES];
	unsigned char ordre[NBNODES];
	
	unsigned char nbNodes = 0;

	map = track.xm->map;
	dimX = track.xm->dimX;
	dimY = track.xm->dimY;

	// preparing for track skeleton extraction
	for(i = dimX * dimY; i--;) {
		if (map[i] < NB_BORDER_TILES){ WPM[i] = 0xFFFE;/* DrawPix (i%dimX, i/dimX, A_NORMAL);*/}
		else if (map[i] >= nbfx){ WPM[i] = 0xFFFF; /*DrawPix (i%dimX, i/dimX, A_NORMAL);*/}
		else WPM[i] = 0;
	}
	
	do {
		mod = 0;
		for(j = 0; j < dimY; j++) {
			for(i = 0; i < dimX; i++) {
				if(WM(i,j) == pass) {
					put4Nb(i,j-1);
					put4Nb(i,j+1);
					put4Nb(i-1,j);
					put4Nb(i+1,j);
				}
			}
		}
		pass--;
	} while(mod);
//	ngetchx();
	// now track skeleton is WM(i,j) == 0, out of road is 0xFFFF
	// road is < 0xFFFE, border is 0xFFFE
	
	// searching for start line -> start point in skeleton
	
	for(j = 1; j < dimY-1 && !nbNodes; j++) {
		for(i = 1; i < dimX-1 && !nbNodes; i++) {
			if(((map[i + j*dimX] == 66) || (map[i + j*dimX] == 67)) && (WM(i,j) == 0)) {
				nodes[0] = (Node*)Malloc(sizeof(Node));
				nodes[0]->x = i;
				nodes[0]->y = j;
				switch(track.direction) {
					case 0:	nodes[0]->routex[0] = i;
									nodes[0]->routey[0] = j-1;
									nodes[0]->routex[1] = i;
									nodes[0]->routey[1] = j+1;
									break;
					case 1:	nodes[0]->routex[0] = i+1;
									nodes[0]->routey[0] = j;
									nodes[0]->routex[1] = i-1;
									nodes[0]->routey[1] = j;
									break;
					case 2:	nodes[0]->routex[0] = i;
									nodes[0]->routey[0] = j+1;
									nodes[0]->routex[1] = i;
									nodes[0]->routey[1] = j-1;
									break;
					case 3:	nodes[0]->routex[0] = i-1;
									nodes[0]->routey[0] = j;
									nodes[0]->routex[1] = i+1;
									nodes[0]->routey[1] = j;
									break;
				}
				nodes[0]->routex[2] = 0;
				nodes[0]->routey[2] = 0;

				WM(i,j) = pass;
				nbNodes++;
				track.startx = i;
				track.starty = j;
				//DrawPix (i, j, A_XOR);
			}
		}
	}
	// extracting nodes of track graph (more than 2 blank points connected)
	for (j = 1; j < dimY-1; j++) {
		for (i = 1; i < dimX-1; i++) {
			mod = 0;
			if (!WM(i,j)) {
				if(!WM(i-1,j-1)){ routex[mod] = i-1; routey[mod++] = j-1; }
				if(!WM(i-1,j)){ routex[mod] = i-1; routey[mod++] = j; }
				if(!WM(i-1,j+1)){ routex[mod] = i-1; routey[mod++] = j+1; }
				if(!WM(i+1,j-1)){ routex[mod] = i+1; routey[mod++] = j-1; }
				if(!WM(i+1,j)){ routex[mod] = i+1; routey[mod++] = j; }
				if(!WM(i+1,j+1)){ routex[mod] = i+1; routey[mod++] = j+1; }
				if(!WM(i,j-1)){ routex[mod] = i; routey[mod++] = j-1; }
				if(!WM(i,j+1)){ routex[mod] = i; routey[mod++] = j+1; }
				if(mod == 3){
					nodes[nbNodes] = (Node*)Malloc(sizeof(Node));
					nodes[nbNodes]->x = i;
					nodes[nbNodes]->y = j;
					nodes[nbNodes]->routex[0] = routex[0];
					nodes[nbNodes]->routex[1] = routex[1];
					nodes[nbNodes]->routex[2] = routex[2];
					nodes[nbNodes]->routey[0] = routey[0];
					nodes[nbNodes]->routey[1] = routey[1];
					nodes[nbNodes]->routey[2] = routey[2];
					WM(routex[0],routey[0]) = nbNodes;
					WM(routex[1],routey[1]) = nbNodes;
					WM(routex[2],routey[2]) = nbNodes;
					nbNodes++;
					WM(i,j) = pass;
				//	DrawPix (i, j, A_XOR);
				}
			}
		}
	}

#define TESTNODE(x,y) \
	if(WM(x,y) != c && WM(x,y) != 0 && WM(x,y) < mod){WM(x,y) = mod; mod--; break;}

#define PARCOURS(x,y) \
	if(!WM(x,y)){a=x; b=y; continue;}


/*FILE* fic;
fic = fopen("zed","wb");
fprintf(fic,"\nnbnodes = %u",nbNodes);*/
	mod = pass-1;
	for(c=0; c<nbNodes; c++) {
		for(j=0; j<2 || (j<3 && c!=0); j++) {
			a = nodes[c]->routex[j];
			b = nodes[c]->routey[j];
			for(;;) {
//fprintf(fic,"\na = %u,b = %u",a,b);

				if((!WM(a,b)) || (WM(a,b) == c)) {
					//DrawPix (a, b, A_XOR);ngetchx();
					WM(a,b) = mod;
					TESTNODE(a-1,b-1);
					TESTNODE(a,b-1);
					TESTNODE(a+1,b-1);
					TESTNODE(a-1,b);
					TESTNODE(a+1,b);
					TESTNODE(a-1,b+1);
					TESTNODE(a,b+1);
					TESTNODE(a+1,b+1);
					PARCOURS(a-1,b-1);
					PARCOURS(a,b-1);
					PARCOURS(a+1,b-1);
					PARCOURS(a-1,b);
					PARCOURS(a+1,b);
					PARCOURS(a-1,b+1);
					PARCOURS(a,b+1);
					PARCOURS(a+1,b+1);

//fprintf(fic,"\n1a = %u,1b = %u",a,b);

					// here we're on a jumper that cut the road
					switch(MAP(a,b)) {
						case 68: updown = 1; leftright = 0; break;
						case 69: updown = 0; leftright = -1; break;
						case 70: updown = -1; leftright = 0; break;
						case 71: updown = 0; leftright = 1; break;
						default: updown = 0; leftright = 0;
					}
					if(!updown && !leftright) break;
					
					do {
						a += leftright; b += updown;
					} while(MAP(a, b) <68 || MAP(a, b) >71);
					
					while(MAP(a, b) >=68 && MAP(a, b) <=71) {
						if(!WM(a,b)) break;
						a += updown; b += leftright;
					}
//fprintf(fic,"\n2a = %u,2b = %u",a,b);
					if(!WM(a,b)) continue;
					a -= updown; b -= leftright;
					while(MAP(a, b) >=68 && MAP(a, b) <=71) {
						if(!WM(a,b)) break;
						a -= updown; b -= leftright;
					}
					
					continue;
				}
				break;
			}
		}
	}
/*fclose(fic);
return;*/
	a=0;
	nodes[0]->routex[1] = 0;
	nodes[0]->routey[1] = 0;
	ordre[0] = 0;
	i = 1;
	
	do {
		for(b=0; b<3; b++) {
			if(nodes[a]->routex[b] == 0 || nodes[a]->routey[b] == 0) continue;
			c = nodes[a]->routex[b];
			d = nodes[a]->routey[b];
			
			for(e=0; e<nbNodes; e++) {
				if (e != a) {
					for(f=0; f<3; f++) {
						if(nodes[e]->routex[f] == 0 || nodes[e]->routey[f] == 0) continue;
						g = nodes[e]->routex[f];
						h = nodes[e]->routey[f];
						if (WM(c,d) == WM(g,h)) {
							nodes[e]->routex[f] = 0;
							nodes[e]->routey[f] = 0;
							ordre[i] = e;
						}
					}		
				}
			}			
		}
		a = ordre[i++];
	} while(i < nbNodes);

//	printf_xy(80,0,"go pour parcours");ngetchx();
// debut bug
//goto finbug;


#define TESTNODE2(x,y) \
	if(WM(x,y) == pass || (WM(x,y) == 0 && d > 2)){mod = 1;}

#define PARCOURS2(x,y) \
	if(WM(x,y) == h){f=x; g=y; continue;}


	d = 0;
	e = 0;
	for(a=0; a<nbNodes; a++) {
		c = ordre[a];
		if (e > d) d = e;
		if (d > e) e = d;
		WM(nodes[c]->x, nodes[c]->y) = d++;e++;
		for(b=0; b<3; b++) {
			if(nodes[c]->routex[b] == 0 || nodes[c]->routey[b] == 0) continue;
			f = nodes[c]->routex[b];
			g = nodes[c]->routey[b];
			h = WM(f,g);
			d^=e; e^=d; d^=e; // echange des variables
			// on parcours a partir de d
			
			mod = 0;
			for (;;) {
			/*	DrawPix (f, g, A_XOR);
				printf_xy(80,10,"%d    ", d);ngetchx();*/
				WM(f,g) = d++;

				TESTNODE2(f-1,g-1);
				TESTNODE2(f,g-1);
				TESTNODE2(f+1,g-1);
				TESTNODE2(f-1,g);
				TESTNODE2(f+1,g);
				TESTNODE2(f-1,g+1);
				TESTNODE2(f,g+1);
				TESTNODE2(f+1,g+1);
				if(mod) break;
				
				PARCOURS2(f-1,g-1);
				PARCOURS2(f,g-1);
				PARCOURS2(f+1,g-1);
				PARCOURS2(f-1,g);
				PARCOURS2(f+1,g);
				PARCOURS2(f-1,g+1);
				PARCOURS2(f,g+1);
				PARCOURS2(f+1,g+1);

				// here we're on a jumper that cut the road
				switch (MAP(f,g)) {
					case 68: updown = 1; leftright = 0; break;
					case 69: updown = 0; leftright = -1; break;
					case 70: updown = -1; leftright = 0; break;
					default: updown = 0; leftright = 1; break;
				}
				do {
					f += leftright; g += updown;
				} while(MAP(f, g) <68 || MAP(f, g) >71);
				
				while(MAP(f, g) >=68 && MAP(f, g) <=71) {
					if(WM(f,g) == h) break;
					f += updown; g += leftright;
				}
				if(WM(f,g) == h) continue;
				f -= updown; g -= leftright;
				while(MAP(f, g) >=68 && MAP(f, g) <=71) {
					if(WM(f,g) == h) break;
					f -= updown; g -= leftright;
				}
				continue;
			
			}
		}	
	}	
	
//Exit(0);
	for(i = 0; i < nbNodes; i++)
		Free(nodes[i]);

#define depass(x,y) if(WM((x),(y)) < 0xC000 && WM((x),(y)) && MAP((x),(y)) >= NB_BORDER_TILES){b += (tabval[a++] = WM((x),(y)));}

	do {
		unsigned short tabval[8];
		pass++;
		do {
			h = 0;
			for(j = 1; j < dimY-1; j++) {
				for(i = 1; i < dimX-1; i++) {
					a=0;b=0;
					if(WM(i,j) == pass){
						h = 1;
						if(MAP(i,j) == 66) {
							WM(i,j) = 0;
						} else if (MAP(i,j) == 67) {
							WM(i,j) = 0;
						} else {
							depass(i-1,j-1)
							depass(i-1,j)
							depass(i-1,j+1)
							depass(i+1,j-1)
							depass(i+1,j)
							depass(i+1,j+1)
							depass(i,j-1)
							depass(i,j+1)
	/*
							depass(i+1,j+1)
							depass(i-1,j-1)
							depass(i-1,j+1)
							depass(i+1,j-1)
							depass(i-1,j)
							depass(i+1,j)
							depass(i,j-1)
							depass(i,j+1)
	*/
							if(!a) continue;
							c = b/a;
							f = 0xFFFE;
							for(b=a;b--;) {
								if(f > (e = abs((signed short)tabval[b]-(signed short)c))) {
									f = e;
									WM(i,j) = 0xC000 | (tabval[b]-1);
								}
							}
						}
					}
				}
			}
			for(j = 0; j < dimY; j++) {
				for(i = 0; i < dimX; i++) {
					if(WM(i,j) >= 0xC000 && WM(i,j) < pass) WM(i,j) &= 0xBFFF;
				}
			}
		}while(h);
	}while(pass != 0xFFFD);
//finbug:
///// fin bug


/*
	for(a=0;a<d;a++){
		for(j = 1; j < dimY-1; j++){
			for(i = 1; i < dimX-1; i++){
				if(WM(i,j) == a) { DrawPix (i, j, A_XOR);}
			}
		}ngetchx();
	}
*/


}


void LoadTrack(ARCH * trackpack) {
	ARCH * trackFile;
	ARCH * fx;

	unsigned short mapnum;
	unsigned char filename[24];
	unsigned char filename2[24];

	fx = aopen (fzeropk1, "tilesfx");
	aread (&nbfx, sizeof (unsigned short), 1, fx);
	effects = fx->apos;
	aclose (fx);
	trackFile = aopen (trackpack, trackfilename);
	track.trackName = trackFile->apos;
	aseek(trackFile, strlen(track.trackName) + 1, SEEK_CUR);
	track.trackComment = trackFile->apos;
	aseek(trackFile, strlen(track.trackComment) + 1, SEEK_CUR);
	aread(&mapnum, sizeof(unsigned short), 1, trackFile);
	aread(&(track.mapstyle), sizeof(unsigned short), 1, trackFile);
	aread(&(track.nbLaps), sizeof(unsigned short), 1, trackFile);
	aread(&(track.gravity), sizeof(unsigned short), 1, trackFile);
	aread(&(track.direction), sizeof(unsigned short), 1, trackFile);
	aclose (trackFile);
	
	strcpy (filename, "tiles\\maptiles\\");
	strcat (filename, styles[track.mapstyle]);
	sprintf (filename2, "maps\\track%u", mapnum);

	track.xm = map_XMapLoad(fzeropk1, fzeropk2, trackpack, "tiles", "tiles", "mask",
														"mask", selection[track.mapstyle], filename2, fill_with[track.mapstyle]);

	WPM = (unsigned short *)Malloc(sizeof(unsigned short) * track.xm->dimX * track.xm->dimY);
}

void LoadSky(void) {
	unsigned char filename[24];
	unsigned char filename2[24];
	strcpy (filename, "tiles\\skies\\");
	strcat (filename, styles[track.mapstyle]);
	strcpy (filename2, "tiles\\skytiles\\");
	strcat (filename2, styles[track.mapstyle]);
	track.sky = map_Load(fzeropk0, fzeropk0, filename, filename2);	
}

void FreeTrack(void) {
	map_XMapFree(track.xm);
	Free (WPM);
}

void FreeSky(void) {
	map_Free(track.sky);	
}
