// C Source File
// Created 04/02/2004; 09:47:48

#include "Mode7Engine.h"

#define MULTI_RES_CUT 16
#define RENDER_SHARPNESS 8 // 1 to 8


INT_HANDLER OldInt1;
INT_HANDLER OldInt4;
#if AUTO_INT_5_GRAYSCALE == 1
unsigned char AI5start;
unsigned short AI5rate;
INT_HANDLER OldInt5;
#endif

#if SHOW_FPS == 1
char fpsStr[3];
#endif
char hwVersion;
volatile char m7_quit = 0;
char nextModif = 0;
short timeCount = 0;
volatile short fCount = 0;
#if ENABLE_LINK == 1
void (*m7_LinkModif)(void);
#endif
void (*m7_Modif)(void);
void (*m7_MoreDisplay)(void);
long K3;
long K4;
long K5;

const signed char SinCosData[] = {
0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 34, 37, 39, 42, 45, 48, 51, 54, 57, 60,
62, 65, 68, 70, 73, 75, 78, 80, 83, 85, 87, 90, 92, 94, 96, 98, 100, 102, 104,
106, 107, 109, 110, 112, 113, 115, 116, 117, 118, 120, 121, 122, 122, 123, 124,
125, 125, 126, 126, 126, 127, 127, 127,
127, 127, 127, 127, 126, 126, 126, 125, 125, 124, 123, 122, 122, 121, 120, 118, 
117, 116, 115, 113, 112, 110, 109, 107, 106, 104, 102, 100, 98, 96, 94, 92, 90, 
87, 85, 83, 80, 78, 75, 73, 70, 68, 65, 62, 60, 57, 54, 51, 48, 45, 42, 39, 37, 
34, 30, 27, 24, 21, 18, 15, 12, 9, 6, 3, 0, -4, -7, -10, -13, -16, -19, -22, 
-25, -28, -31, -35, -38, -40, -43, -46, -49, -52, -55, -58, -61, -63, -66, -69, 
-71, -74, -76, -79, -81, -84, -86, -88, -91, -93, -95, -97, -99, -101, -103, 
-105, -107, -108, -110, -111, -113, -114, -116, -117, -118, -119, -121, -122, 
-123, -123, -124, -125, -126, -126, -127, -127, -127, -128, -128, -128, -128, 
-128, -128, -128, -127, -127, -127, -126, -126, -125, -124, -123, -123, -122, 
-121, -119, -118, -117, -116, -114, -113, -111, -110, -108, -107, -105, -103, 
-101, -99, -97, -95, -93, -91, -88, -86, -84, -81, -79, -76, -74, -71, -69, -66, 
-63, -61, -58, -55, -52, -49, -46, -43, -40, -38, -35, -31, -28, -25, -22, -19, 
-16, -13, -10, -7, -4, 0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 34, 37, 39, 42, 
45, 48, 51, 54, 57, 60, 62, 65, 68, 70, 73, 75, 78, 80, 83, 85, 87, 90, 92, 94, 
96, 98, 100, 102, 104, 106, 107, 109, 110, 112, 113, 115, 116, 117, 118, 120, 
121, 122, 122, 123, 124, 125, 125, 126, 126, 126, 127, 127, 127};

const signed char * Sin128Table = SinCosData;
const signed char * Cos128Table = SinCosData+64;

signed char CosTable[NBDIR];
signed char SinTable[NBDIR];
short m7starts[SIZE_Y*2];
short m7vectors[SIZE_Y];
short m7startsL[SIZE_Y*2];
long m7vectorsL[SIZE_Y*2];
short tabstep[SIZE_Y];
short Dir=0;	// direction
#if ENABLE_GRAYSCALE == 1
unsigned char SkyChange = 2;
#else
unsigned char SkyChange = 1;
#endif
short X=0;		// x camera
short Y=0;		// y camera
unsigned char * MapData;
#if ENABLE_LARGE_MAPS == 2
unsigned char ** MapTiles;
unsigned short TilesOffset;
#else
unsigned char * Map0;
#endif
unsigned char * Sky0;
#if ENABLE_GRAYSCALE == 1
unsigned char * Buff;
#if ENABLE_LARGE_MAPS != 2
unsigned char * Map1;
#endif
unsigned char * Sky1;
unsigned char Plane = 0;
unsigned char * Plane0;
unsigned char * Plane1;
unsigned char * Planes[4];
#else
char DispSky[SIZE_SKY_X*SIZE_SKY_Y];
char Virtual[LCD_SIZE];
#endif
short DimX;
short DimY;
short NumByte=0;

short m7_ProjXYZ(Sprite * sprite, short * Xscreen, short * Yscreen, short * Zscreen, short * scaling, short nbscale);

#define ts_nx(x) #x 
#define ts(x) ts_nx(x)

#define IN_MAP_ASM(SHIFT) "
move.l %d4,%d5
asr.l #(" ts(RENDER_SHARPNESS) "),%d5
add.w %d1,%d5
move.l %d3,%d6
asr.l #(" ts(RENDER_SHARPNESS) "),%d6
add.w %d2,%d6

move.w %d5,%d7
swap %d7
move.w %d6,%d7
asr.w #(" ts(TILES_SHIFT) "),%d5
asl.w #(" ts(10-TILES_SHIFT) "),%d5
asr.w #(" ts(TILES_SHIFT) "),%d7
add.w %d7,%d5
lsl.w #2,%d5
swap %d7
lea %a4@(%d5.w),%a5
and.w #(" ts(TILES_SIZE - 1) "),%d6
and.w #(" ts(TILES_SIZE - 1) "),%d7
asl.w #(" ts(TILES_SHIFT) "),%d7
add.w %d6,%d7
movea.l %a5@,%a5
adda %d7,%a5
add.l %a3@,%d4
add.l %a3@(4),%d3

tst.b %a5@
.word 0x6704 | beq +4
or.w #(" ts(PIX >> (SHIFT)) "),%a0@
adda.w %a6,%a5
tst.b %a5@
.word 0x6704 | beq +4
or.w #(" ts(PIX >> (SHIFT)) "),%a1@
"

#define COORD_XY \
	coordx = (cumulx>>RENDER_SHARPNESS) + coordx0; \
	coordy = (cumuly>>RENDER_SHARPNESS) + coordy0; \
	cumuly += vectory; \
	cumulx += vectorx;

#if ENABLE_GRAYSCALE == 1

#define IN_MAP_2(SHIFT) \
	if(map0[bytemap] & offsetmap)	*dispword0 |= (PIX >> SHIFT); \
	if(map1[bytemap] & offsetmap)	*dispword1 |= (PIX >> SHIFT);

#define IN_MAP_3(SHIFT) \
	if(*mapoffset)	*dispword0 |= (PIX >> SHIFT); \
	if(*(mapoffset+tilesoffset))	*dispword1 |= (PIX >> SHIFT);	

#else

#define IN_MAP_2(SHIFT) \
	if(map0[bytemap] & offsetmap)	*dispword0 |= (PIX >> SHIFT); \

#define IN_MAP_3(SHIFT) \
	if(*mapoffset)	*dispword0 |= (PIX >> SHIFT);

#endif
		
#if ENABLE_LARGE_MAPS == 0

#define IN_MAP(SHIFT) \
	COORD_XY \
	bytemap = coordx+coordy*dimx; \
	offsetmap = 1 << (bytemap & 0x7); \
	bytemap >>= 3; \
	IN_MAP_2(SHIFT)

#endif

#if ENABLE_LARGE_MAPS == 1

#define IN_MAP(SHIFT) \
	COORD_XY \
	offsetmap = 1 << (coordx & 0x7); \
	bytemap = ((long)coordx+(long)coordy*(long)dimx) >> 3; \
	IN_MAP_2(SHIFT)

#endif

#if ENABLE_LARGE_MAPS == 2
#if FORCE_MAP_WITDH_TO_1024 == 1

#define IN_MAP(SHIFT) \
	COORD_XY \
	mapoffset = maptiles[((coordy >> TILES_SHIFT) << (10-TILES_SHIFT)) + (coordx >> TILES_SHIFT)] + ((coordy & (TILES_SIZE - 1)) << TILES_SHIFT) + (coordx & (TILES_SIZE - 1)); \
	IN_MAP_3(SHIFT)

#else

#define IN_MAP(SHIFT) \
	COORD_XY \
	mapoffset = maptiles[(coordy >> TILES_SHIFT) * dimx + (coordx >> TILES_SHIFT)] + ((coordy & (TILES_SIZE - 1)) << TILES_SHIFT) + (coordx & (TILES_SIZE - 1)); \
	IN_MAP_3(SHIFT)

#endif

#endif


#if ZOOM_SCR_HORZ == 1
#define PIX 0x8000
#elif ZOOM_SCR_HORZ == 2
#define PIX 0xC000
#elif ZOOM_SCR_HORZ == 4
#define PIX 0xF000
#elif ZOOM_SCR_HORZ == 8
#define PIX 0xFF00
#endif

#define HARDWARE_FREQUENCY  23967
static volatile unsigned short HWcounter=0;

DEFINE_INT_HANDLER (AI1) {
#if AUTO_INT_5_GRAYSCALE == 0
  ExecuteHandler (OldInt1);
#endif

#if ENABLE_LINK == 1
	// for linkplay
	if(linkenabled) {
		LinkRecv();
		if(received == 1) {
			m7_LinkModif(); // master -> environement modif, slave -> send back 
			received = 2; // modif done
			if(!linkmode) // slave
				m7_Modif(); // slave -> environement modif
		}
	}
#endif
	
// [Thanks to geogeo from www.tigen.org for this code]
	//HARDWARE VERSION 1.0 
	if (hwVersion==1) {
		//Incrmentation
		HWcounter+=HARDWARE_FREQUENCY;
	
		//Execution interruption
		if (HWcounter<=32768)
			return;
		//Remise  zro
		HWcounter-=32768;
	}
// [/Thanks to geogeo from www.tigen.org for this code]
	timeCount++;
	if (timeCount == (256)) {
		timeCount = 0;
#if SHOW_FPS == 1
		sprintf (fpsStr, "%d", fCount);
		DrawStr (0, 0, fpsStr, A_REPLACE);
#endif
		fCount = 0;
	}
	
#if ENABLE_LINK == 1
	if(linkenabled) {
		timeIncr();		// test timeout
		if(!linkmode) // slave
			return;
	}
#endif
	
	if (!nextModif) {
		nextModif = GAME_SPEED;
		m7_Modif(); // if link, master send
	}
	
	if(nextModif)
		nextModif--;
}

#if AUTO_INT_5_GRAYSCALE == 1
DEFINE_INT_HANDLER (AI5) {
  ExecuteHandler (OldInt5);
  ExecuteHandler (OldInt1);
}
#endif

static inline void m7_DrawSky(void) {
	unsigned char i;
#if ENABLE_GRAYSCALE == 1
	unsigned char * offset0=OFFSET_SKY_HORZ+ 30*OFFSET_SKY_VERT + Plane0;
	unsigned char * offset1=OFFSET_SKY_HORZ+ 30*OFFSET_SKY_VERT + Plane1;
	unsigned char * offset12 = NULL, *sky1offset, *sky1offset2 = NULL;
#else
	unsigned char * offset0=OFFSET_SKY_HORZ+ 30*OFFSET_SKY_VERT + Virtual;
#endif
	unsigned char * offset02 = NULL;
	unsigned char * sky0offset;
	unsigned char * sky0offset2 = NULL;
	unsigned short length, length2=0;
	const short Byte = NumByte >> NBDIVSCROLL;
	
	length = SIZE_SKY_X - Byte;
	if(length > SIZE_SKY_HORZ) {
		length = SIZE_SKY_HORZ;
	} else {
		length2 = SIZE_SKY_HORZ - length;
		sky0offset2 = Sky0;
#if ENABLE_GRAYSCALE == 1
		sky1offset2 = Sky1;
#endif
		offset02 = offset0 + length;
#if ENABLE_GRAYSCALE == 1
		offset12 = offset1 + length;
#endif
	}
	sky0offset = Sky0+Byte;
#if ENABLE_GRAYSCALE == 1
	sky1offset = Sky1+Byte;
#endif
	
	for(i=SIZE_SKY_Y;i--;) {
		memcpy(offset0, sky0offset, length);
#if ENABLE_GRAYSCALE == 1
		memcpy(offset1, sky1offset, length);
#endif
		sky0offset+=SIZE_SKY_X;
#if ENABLE_GRAYSCALE == 1
		sky1offset+=SIZE_SKY_X;
#endif
		
		if (length < SIZE_SKY_HORZ) {
			memcpy(offset02, sky0offset2, length2);
#if ENABLE_GRAYSCALE == 1
			memcpy(offset12, sky1offset2, length2);
#endif
			sky0offset2+=SIZE_SKY_X;
#if ENABLE_GRAYSCALE == 1
			sky1offset2+=SIZE_SKY_X;
#endif
			offset02+=30;
#if ENABLE_GRAYSCALE == 1
			offset12+=30;
#endif
		}
		offset0+=30;
#if ENABLE_GRAYSCALE == 1
		offset1+=30;
#endif
	}

}

extern inline void m7_DrawFrame(void);
#if ASM_DRAWFRAME == 1
#if ENABLE_GRAYSCALE == 0 || FORCE_MAP_WITDH_TO_1024 == 0
#error "ENABLE_GRAYSCALE and FORCE_MAP_WITDH_TO_1024 flags must be setted"
#endif

asm("
.text
m7_DrawFrame:
movem.l %d0-%d7/%a0-%a6,%a7@- | pushes all registers
move.w Dir,%d0
lea SinTable,%a0
lea CosTable,%a1
moveq #0,%d3
moveq #0,%d4
move.b %a0@(%d0.w),%d3
ext.w %d3
move.b %a1@(%d0.w),%d4
ext.w %d4
| computing of m7startsL
lea m7starts,%a0
lea m7startsL,%a1
move.w Y,%a2
move.w X,%a3
moveq #(" ts(SIZE_Y-1) "),%d0
loopM7S:
move.w %a0@+,%d1
move.w %d1,%d2
move.w %a0@+,%d5
move.w %d5,%d6
muls.w %d4,%d1
muls.w %d3,%d2
muls.w %d4,%d6
muls.w %d3,%d5
sub.l %d5,%d1
add.l %d6,%d2
add.l %a2,%d1
add.l %a3,%d2
asr.l #(" ts(SINCOS + ZOOM) "),%d1
asr.l #(" ts(SINCOS + ZOOM) "),%d2
move.w %d1,%a1@+
move.w %d2,%a1@+
dbra %d0,loopM7S
| computing of m7vectorsL
neg.w %d3
lea m7vectors,%a0
lea m7vectorsL,%a1
moveq #(" ts(SIZE_Y-1) "),%d0
loopM7V:
move.w %a0@+,%d1
move.w %d1,%d2
muls.w %d3,%d1
muls.w %d4,%d2
asr.l #(" ts(SINCOS + ZOOM) "),%d1
asr.l #(" ts(SINCOS + ZOOM) "),%d2
move.l %d1,%a1@+
move.l %d2,%a1@+
dbra %d0,loopM7V

movea.l MapTiles,%a4
movea.w TilesOffset,%a6
movea.l Plane0,%a0
movea.l Plane1,%a1
lea %a0@(" ts(2*(OFFSET_SCR_HORZ+ 15*OFFSET_SCR_VERT)) "),%a0
lea %a1@(" ts(2*(OFFSET_SCR_HORZ+ 15*OFFSET_SCR_VERT)) "),%a1
lea m7startsL,%a2
lea m7vectorsL,%a3
"
#if ENABLE_MULTI_RES == 1
"
move.w #(" ts(MULTI_RES_CUT-1) "),%d0
"
#else
"
move.w #(" ts(SIZE_Y-1) "),%d0
"
#endif
"
loopj:
swap %d0
move.w %a2@+,%d1
move.w %a2@+,%d2
moveq #0,%d3
moveq #0,%d4
move.w #(" ts((SIZE_X*ZOOM_SCR_HORZ/16)-1) "),%d0
loopi:
clr.w %a0@
clr.w %a1@
"
#if ZOOM_SCR_HORZ <= 8
IN_MAP_ASM(0)
IN_MAP_ASM(ZOOM_SCR_HORZ)
#endif

#if ZOOM_SCR_HORZ <= 4
IN_MAP_ASM(ZOOM_SCR_HORZ * 2)
IN_MAP_ASM(ZOOM_SCR_HORZ * 3)
#endif

#if ZOOM_SCR_HORZ <= 2
IN_MAP_ASM(ZOOM_SCR_HORZ * 4)
IN_MAP_ASM(ZOOM_SCR_HORZ * 5)
IN_MAP_ASM(ZOOM_SCR_HORZ * 6)
IN_MAP_ASM(ZOOM_SCR_HORZ * 7)
#endif

#if ZOOM_SCR_HORZ == 1
IN_MAP_ASM(ZOOM_SCR_HORZ * 8)
IN_MAP_ASM(ZOOM_SCR_HORZ * 9)
IN_MAP_ASM(ZOOM_SCR_HORZ * 10)
IN_MAP_ASM(ZOOM_SCR_HORZ * 11)
IN_MAP_ASM(ZOOM_SCR_HORZ * 12)
IN_MAP_ASM(ZOOM_SCR_HORZ * 13)
IN_MAP_ASM(ZOOM_SCR_HORZ * 14)
IN_MAP_ASM(ZOOM_SCR_HORZ * 15)
#endif

#if ZOOM_SCR_VERT == 2
"
move.w %a0@,%a0@(30)
move.w %a1@,%a1@(30)
"
#endif
"
addq.l #2,%a0
addq.l #2,%a1

dbra %d0,loopi
addq.l #8,%a3
swap	%d0	
lea %a0@(" ts(2*(15*ZOOM_SCR_VERT-((ZOOM_SCR_HORZ*SIZE_X)/16))) "),%a0
lea %a1@(" ts(2*(15*ZOOM_SCR_VERT-((ZOOM_SCR_HORZ*SIZE_X)/16))) "),%a1
dbra %d0,loopj
"
#if ENABLE_MULTI_RES == 1
"
move.w #(" ts(((SIZE_Y-MULTI_RES_CUT)/2) - 1) "),%d0
loopj2:
swap %d0
move.w %a2@+,%d1
move.w %a2@,%d2
addq.l #6,%a2
moveq #0,%d3
moveq #0,%d4
move.w #(" ts((SIZE_X*ZOOM_SCR_HORZ/16)-1) "),%d0
loopi2:
clr.w %a0@
clr.w %a1@
"

#if ZOOM_SCR_HORZ <= 8
IN_MAP_ASM(0)
IN_MAP_ASM(ZOOM_SCR_HORZ)
#endif

#if ZOOM_SCR_HORZ <= 4
IN_MAP_ASM(ZOOM_SCR_HORZ * 2)
IN_MAP_ASM(ZOOM_SCR_HORZ * 3)
#endif

#if ZOOM_SCR_HORZ <= 2
IN_MAP_ASM(ZOOM_SCR_HORZ * 4)
IN_MAP_ASM(ZOOM_SCR_HORZ * 5)
IN_MAP_ASM(ZOOM_SCR_HORZ * 6)
IN_MAP_ASM(ZOOM_SCR_HORZ * 7)
#endif

#if ZOOM_SCR_HORZ == 1
IN_MAP_ASM(ZOOM_SCR_HORZ * 8)
IN_MAP_ASM(ZOOM_SCR_HORZ * 9)
IN_MAP_ASM(ZOOM_SCR_HORZ * 10)
IN_MAP_ASM(ZOOM_SCR_HORZ * 11)
IN_MAP_ASM(ZOOM_SCR_HORZ * 12)
IN_MAP_ASM(ZOOM_SCR_HORZ * 13)
IN_MAP_ASM(ZOOM_SCR_HORZ * 14)
IN_MAP_ASM(ZOOM_SCR_HORZ * 15)
#endif

"
move.w %a0@,%a0@(30)
move.w %a1@,%a1@(30)

addq.l #2,%a0
addq.l #2,%a1

dbra %d0,loopi2
add.l #16,%a3
swap	%d0	
lea %a0@(" ts(2*(15*2-((ZOOM_SCR_HORZ*SIZE_X)/16))) "),%a0
lea %a1@(" ts(2*(15*2-((ZOOM_SCR_HORZ*SIZE_X)/16))) "),%a1
dbra %d0,loopj2
"
#endif
"
movem.l %a7@+,%d0-%d7/%a0-%a6 | pops all registers
rts
");
#else

static inline void m7_DrawFrame(void) {

	unsigned char i,j;

	short cosdir = CosTable[Dir];
	short sindir = SinTable[Dir];
	signed short coordy0, coordx0;
	signed short coordy, coordx;
	signed long cumulx, cumuly;
	signed long vectorx, vectory;
	short * pm7startsL = m7startsL;
	long * pm7vectorsL = m7vectorsL;
	short * pm7starts = m7starts;
	short * pm7vectors = m7vectors;

	// computing of m7startsL
	for(i=SIZE_Y;i--;) {
		cumulx = cumuly = *(pm7starts++);
		coordx = coordy = *(pm7starts++);
		(short)cumuly *= cosdir;
		(short)cumulx *= sindir;
		(short)coordx *= cosdir;
		(short)coordy *= sindir;
		cumuly -= coordy;
		cumulx += coordx;
		cumuly += Y;
		cumulx += X;
		cumuly >>= (SINCOS+ZOOM);
		cumulx >>= (SINCOS+ZOOM);
		*(pm7startsL++) = cumuly;
		*(pm7startsL++) = cumulx;
	}
	pm7startsL = m7startsL;

	// computing of m7vectorsL
	sindir = -sindir;
	for(i=SIZE_Y;i--;) {
		cumulx = cumuly = *(pm7vectors++);
		cumuly = ((long)cumuly*sindir)>>(SINCOS + ZOOM);
		cumulx = ((long)cumulx*cosdir)>>(SINCOS + ZOOM);
		*(pm7vectorsL++) = cumuly;
		*(pm7vectorsL++) = cumulx;
	}
	pm7vectorsL = m7vectorsL;

#if FORCE_MAP_WITDH_TO_1024 == 0
	const signed short dimx = DimX;
#endif
#if ENABLE_LARGE_MAPS == 2
	unsigned char ** maptiles = MapTiles;
	unsigned char * mapoffset;
#if ENABLE_GRAYSCALE == 1
	const unsigned short tilesoffset = TilesOffset;
#endif
#else
	unsigned short bytemap, offsetmap;
	const unsigned char * map0 = Map0;
#if ENABLE_GRAYSCALE == 1
	const unsigned char * map1 = Map1;
#endif
#endif

#if ENABLE_GRAYSCALE == 1
	unsigned short * dispword0 = &((short*)Plane0)[OFFSET_SCR_HORZ+ 15*OFFSET_SCR_VERT];
	unsigned short * dispword1 = &((short*)Plane1)[OFFSET_SCR_HORZ+ 15*OFFSET_SCR_VERT];
#else
	unsigned short * dispword0 = &((short*)Virtual)[OFFSET_SCR_HORZ+ 15*OFFSET_SCR_VERT];
#endif


#if ENABLE_MULTI_RES == 1
	for(j=MULTI_RES_CUT; j--;) {
#else
	for(j=SIZE_Y; j--;) {
#endif

		coordy0 = *(pm7startsL++);
		coordx0 = *(pm7startsL++);
		vectory = *(pm7vectorsL++);
		vectorx = *(pm7vectorsL++);
		cumulx = cumuly = 0;

		for(i=(SIZE_X*ZOOM_SCR_HORZ/16); i--;) {
			*dispword0 = 0;
#if ENABLE_GRAYSCALE == 1
			*dispword1 = 0;
#endif

#if ZOOM_SCR_HORZ <= 8
			IN_MAP(0)
			
			IN_MAP(ZOOM_SCR_HORZ)
#endif

#if ZOOM_SCR_HORZ <= 4
			IN_MAP(ZOOM_SCR_HORZ * 2)
			
			IN_MAP(ZOOM_SCR_HORZ * 3)
#endif

#if ZOOM_SCR_HORZ <= 2
			IN_MAP(ZOOM_SCR_HORZ * 4)
			
			IN_MAP(ZOOM_SCR_HORZ * 5)
			
			IN_MAP(ZOOM_SCR_HORZ * 6)
			
			IN_MAP(ZOOM_SCR_HORZ * 7)
#endif

#if ZOOM_SCR_HORZ == 1
			IN_MAP(ZOOM_SCR_HORZ * 8)
			
			IN_MAP(ZOOM_SCR_HORZ * 9)
			
			IN_MAP(ZOOM_SCR_HORZ * 10)
			
			IN_MAP(ZOOM_SCR_HORZ * 11)
			
			IN_MAP(ZOOM_SCR_HORZ * 12)
			
			IN_MAP(ZOOM_SCR_HORZ * 13)
			
			IN_MAP(ZOOM_SCR_HORZ * 14)
			
			IN_MAP(ZOOM_SCR_HORZ * 15)
#endif

#if ZOOM_SCR_VERT == 2
			*(dispword0 + 15) = *dispword0;
#if ENABLE_GRAYSCALE == 1
			*(dispword1 + 15) = *dispword1;
#endif

#elif ZOOM_SCR_VERT > 1
			unsigned short offset = 0;
			unsigned char k;
			
			for(k=(ZOOM_SCR_VERT - 1); k--;) {
				offset += 15;
				
				*(dispword0+offset) = *dispword0;
#if ENABLE_GRAYSCALE == 1
				*(dispword1+offset) = *dispword1;
#endif
			}
#endif

			dispword0++;
#if ENABLE_GRAYSCALE == 1
			dispword1++;
#endif
		}
		
		dispword0 += 15*ZOOM_SCR_VERT-((ZOOM_SCR_HORZ*SIZE_X)/16);
#if ENABLE_GRAYSCALE == 1
		dispword1 += 15*ZOOM_SCR_VERT-((ZOOM_SCR_HORZ*SIZE_X)/16);
#endif
	}

#if ENABLE_MULTI_RES == 1
	for(j=(SIZE_Y-MULTI_RES_CUT)/2; j--;) {
		coordy0 = *(pm7startsL++);
		coordx0 = *(pm7startsL++);
		vectory = *(pm7vectorsL++);
		vectorx = *(pm7vectorsL++);
		cumulx = cumuly = 0;
		pm7startsL+=2;
		pm7vectorsL+=2;

		for(i=(SIZE_X*ZOOM_SCR_HORZ/16); i--;) {
			*dispword0 = 0;
#if ENABLE_GRAYSCALE == 1
			*dispword1 = 0;
#endif

#if ZOOM_SCR_HORZ <= 8
			IN_MAP(0)
			
			IN_MAP(ZOOM_SCR_HORZ)
#endif

#if ZOOM_SCR_HORZ <= 4
			IN_MAP(ZOOM_SCR_HORZ * 2)
			
			IN_MAP(ZOOM_SCR_HORZ * 3)
#endif

#if ZOOM_SCR_HORZ <= 2
			IN_MAP(ZOOM_SCR_HORZ * 4)
			
			IN_MAP(ZOOM_SCR_HORZ * 5)
			
			IN_MAP(ZOOM_SCR_HORZ * 6)
			
			IN_MAP(ZOOM_SCR_HORZ * 7)
#endif

#if ZOOM_SCR_HORZ == 1
			IN_MAP(ZOOM_SCR_HORZ * 8)
			
			IN_MAP(ZOOM_SCR_HORZ * 9)
			
			IN_MAP(ZOOM_SCR_HORZ * 10)
			
			IN_MAP(ZOOM_SCR_HORZ * 11)
			
			IN_MAP(ZOOM_SCR_HORZ * 12)
			
			IN_MAP(ZOOM_SCR_HORZ * 13)
			
			IN_MAP(ZOOM_SCR_HORZ * 14)
			
			IN_MAP(ZOOM_SCR_HORZ * 15)
#endif

			*(dispword0 + 15) = *dispword0;
#if ENABLE_GRAYSCALE == 1
			*(dispword1 + 15) = *dispword1;
#endif
			dispword0++;
#if ENABLE_GRAYSCALE == 1
			dispword1++;
#endif
		}
	
		dispword0 += 15*2-((ZOOM_SCR_HORZ*SIZE_X)/16);
#if ENABLE_GRAYSCALE == 1
		dispword1 += 15*2-((ZOOM_SCR_HORZ*SIZE_X)/16);
#endif
	}
#endif
}
#endif

static inline void m7_Display(void) {
#if (ENABLE_SPRITES == 1) || (ENABLE_FIRST_PLANE_SPRITES == 1)
	unsigned short i;
#endif
#if ENABLE_SPRITES == 1
	Sprite * sprite;
	short Xscreen, Yscreen, Zscreen, scaling;
#endif

#if ENABLE_SPRITES == 1

	nbDisplayedSprites = 0;
	
	for (i=MAXSPRT; i--;)
		if (AddedSprites[i] == 1) {
			sprite = AllSpriteList[i];
			if (m7_ProjXYZ(sprite, &Xscreen, &Yscreen, &Zscreen, &scaling, sprite->nbScales))
				m7sprites_SetDisplayed(i, Xscreen, Yscreen, Zscreen, Dir, sprite->dir, scaling);
		}
	
	m7sprites_SortDisplayedSpriteList();
#endif

	m7_DrawFrame();

#if ENABLE_SKY == 1
	if(SkyChange) {
		SkyChange--;
		m7_DrawSky();
	}
#endif

#if ENABLE_SPRITES == 1
	for (i=0; i < nbDisplayedSprites; i++)
#if ENABLE_GRAYSCALE == 1
		m7sprite_Display(i, Plane0, Plane1);
#else
		m7sprite_Display(i, Virtual);
#endif
	
	
#endif

#if ENABLE_FIRST_PLANE_SPRITES == 1
	for (i=0; i < MAXSPRT; i++)
		if (AddedSprites[i] == 2) {
#if ENABLE_GRAYSCALE == 1
			m7sprite_Display1stPlane(i, Plane0, Plane1);
#else
			m7sprite_Display1stPlane(i, Virtual);
#endif
		}

#endif

#if ENABLE_MORE_DISPLAY == 1
	m7_MoreDisplay();
#endif

#if ENABLE_GRAYSCALE == 1
	m7_DBufToggle();
#else
	memcpy(LCD_MEM, Virtual, LCD_SIZE);
#endif
}


void m7_SetLoopFunc(void (*modifFunc)(void)) {
#if ENABLE_LINK == 1
	if(linkenabled) {
		if(linkmode) 
			m7_LinkModif = modifFunc;
		else
			m7_Modif = modifFunc;
	}
	else
#endif
		m7_Modif = modifFunc;
}


void m7_LoopInit(void) {
	timeCount = 0;
	fCount = 0;
	hwVersion = HW_VERSION;
#if ENABLE_LINK == 1
	if(linkenabled) {
		if(linkmode)
			m7_Modif = masterModif;
		else
			m7_LinkModif = slaveModif;
	}
#endif
}

void m7_LoopEnd(void) {
	m7_quit = 1;
	ReSetIntVector(AUTO_INT_1);
#if AUTO_INT_5_GRAYSCALE == 1
	ReSetIntVector(AUTO_INT_5);
#endif
}

void m7_LoopStart(void) {
	m7_quit = 0;
  OldInt1 = SetIntVector (AUTO_INT_1, AI1);
#if AUTO_INT_5_GRAYSCALE == 1
	// set the AI5 to the same frequency as AI1 (i.e. osc2/2^11)
	PRG_setRate (1); 
	PRG_setStart(0xFD); // OxFD = 257-((2^11)/(2^9))
  OldInt5 = SetIntVector (AUTO_INT_5, AI5);
#endif
	while(!m7_quit) {
		m7_Display();
		fCount++;
	}	
}

void m7_InitMoreDisplay(void (*moreDispFunc)(void)) {
	m7_MoreDisplay = moreDispFunc;
}

static inline void m7_CosAndSin(void) {
	unsigned short i;
#define PAS (256/NBDIR)
	for(i = NBDIR; i--;) {
		CosTable[i] = Cos128Table[i*PAS]/(1<<(7-SINCOS));
		SinTable[i] = Sin128Table[i*PAS]/(1<<(7-SINCOS));
	}
}

unsigned int Log2(unsigned long x) {
  unsigned int j=0;
  if(x>=1L<<16) x >>=16, j+=16;
  unsigned int y=x;
  if(y>=1<<8) y >>=8, j+=8;
  if(y>=1<<4) y >>=4, j+=4;
  if(y>=1<<2) y >>=2, j+=2;
  if(y>=1<<1) y >>=1, j+=1;
	return j;
}

void m7_CreateMatrix(short SizeHorz, short ViewL, short ViewF) { 
  short i;
  unsigned short * pM7S = m7starts;
  unsigned short * pM7V = m7vectors;
  K3 = SizeHorz * (SIZE_Y * (ViewF - 1)); 
  const long K1 = -K3*ViewL*ViewL; 
  const long K2 = 2*SIZE_X*ViewF; 
  K4 = (SizeHorz-1)*ViewF; 
   
  K5 = SizeHorz*(-(ViewF-1)*ViewL); 
   
  long val = ((SIZE_Y - 1) * K4 - K3); 
 
  for(i=SIZE_Y; i--; ) { 
		long q = K2 * val;
		int z = Log2(q) - 15; 
		if (z<0) z=0; 
		long K1z = K1>>z; q>>=z; 
		*(pM7S++) = (i*K5)/(val + val);
		tabstep[SIZE_Y - i - 1] = (K1<<2)/(K2 * val);
		if(tabstep[SIZE_Y - i - 1] == 0) tabstep[SIZE_Y - i - 1] = 1;
		val -= K4; 
		*(pM7S++) = (short)(((SIZE_X/2)) * K1z / (short)q);
		*(pM7V++) = (short)(-(1<<RENDER_SHARPNESS) * K1z / (short)q);
  }
}

short m7_ProjXYZ(Sprite * sprite, short * Xscreen, short * Yscreen, short * Zscreen, short * scaling, short nbscale) {
	const short x = ((sprite->x - X)>>SINCOS), y = ((sprite->y - Y)>>SINCOS), z = sprite->z;
	const short cosdir = CosTable[Dir];
	const short sindir = SinTable[Dir];
	const short Py = (y * cosdir + x * sindir)>>SINCOS;
	if (Py > FRONT_CLIP_DIST)	return 0;
	if (Py < -BACK_CLIP_DIST)	return 0;
	const short Px = (y * sindir - x * cosdir)>>(SINCOS - 2);

	*Yscreen = (K3-K4)*(Py+Py)/(K4*(Py+Py)-K5);
	const short Yscreen2 = (*Yscreen < 0 ? 0 : *Yscreen);
	
	*scaling = ((FRONT_CLIP_DIST - Py) * nbscale) / FRONT_CLIP_DIST;
//	*scaling = ((FRONT_CLIP_DIST - DistY) * nbscale) / FRONT_CLIP_DIST;
	*Zscreen = ((FRONT_CLIP_DIST - Py) * z) / FRONT_CLIP_DIST;
//	*Zscreen = ((FRONT_CLIP_DIST - DistY) * z) / FRONT_CLIP_DIST;
//	if(*scaling < 0) *scaling = 0;
	if(*scaling >= nbscale) *scaling = nbscale-1;
	*Xscreen = (Px*(ZOOM_SCR_HORZ))/(tabstep[SIZE_Y - 1 - Yscreen2]) + (SIZE_X*ZOOM_SCR_HORZ)/2 + (OFFSET_SCR_HORZ << 4);
	*Yscreen = OFFSET_SCR_VERT + (SIZE_Y*ZOOM_SCR_VERT) - (*Yscreen * ZOOM_SCR_VERT) - 1;
	
	return (*Xscreen >= ((CLIP_LEFT*8) - HORZ_MARGE) && *Xscreen < ((CLIP_RIGHT*8) + HORZ_MARGE) && 
	(*Yscreen)-(*Zscreen) >= (CLIP_UP - VERT_MARGE) && *Yscreen < (CLIP_DOWN + VERT_MARGE));
}

void m7_Init(short SizeHorz, short ViewL, short ViewF) {
	//reinit of static values
	OldInt1 = NULL;
	OldInt4 = NULL;
#if AUTO_INT_5_GRAYSCALE == 1
	OldInt5 = NULL;
#endif
	m7_quit = 0;
	nextModif = 0;
	timeCount = 0;
	fCount = 0;
	HWcounter=0;
	Dir=0;
	X=0;
	Y=0;
	NumByte=0;
	linktype = 0;
	#if ENABLE_GRAYSCALE == 1
	Plane = 0;
	SkyChange = 2;
	#else
	SkyChange = 1;
	#endif
	m7_CosAndSin();
	m7_CreateMatrix(SizeHorz, ViewL, ViewF);

}

void m7_ReInit(short SizeHorz, short ViewL, short ViewF) {
	m7_CreateMatrix(SizeHorz, ViewL, ViewF);
}

void m7_LoadIdentity(void) {
	Dir=0;
	X=0;
	Y=0;
}

void m7_ScrollSky(short s) {
	NumByte+=s+(SIZE_SKY_X << NBDIVSCROLL);
	NumByte%=(SIZE_SKY_X << NBDIVSCROLL);	
#if ENABLE_GRAYSCALE == 1
	SkyChange = 2;
#else
	SkyChange = 1;
#endif
}

void m7_Rotate(short angle) {
	short prevDir = Dir;
	Dir+=angle+NBDIR;
	Dir%=NBDIR;
	m7_ScrollSky((prevDir-Dir) * SCROLL);
}

void m7_SetDir(unsigned short dir) {
	short prevDir = Dir;
	Dir=dir;
	m7_ScrollSky((prevDir-Dir) * SCROLL);
}

void m7_LookAt(short x, short y) {
	unsigned short i, newdir = Dir;
	signed short Py;
	signed short proj = 0;

	y -=(Y>>SINCOS);
	x -=(X>>SINCOS);

	for (i = NBDIR; i--;) {
		Py = (y * CosTable[i] + x * SinTable[i]);
		if (proj < Py) {
			proj = Py;
			newdir = i;
		}
	}
	
	m7_SetDir(newdir);
}

void m7_TranslateXY(short x, short y) {
	X+=x << SINCOS;
	Y+=y << SINCOS;
}

void m7_TranslateDir(short dist, unsigned short dir) {
	X+= (dist*SinTable[dir]);
	Y+= (dist*CosTable[dir]);
}

void m7_Translate(short dist) {
	X+= (dist*SinTable[Dir]);
	Y+= (dist*CosTable[Dir]);
}

void m7_SetCameraPos(short x, short y) {
	X=x << SINCOS;
	Y=y << SINCOS;
}

void m7_SetCameraPos2(short x, short y) {
	X=x;
	Y=y;
}

void m7_GetCameraPos(short * x, short * y) {
	*x=X;
	*y=Y;
}

#if ENABLE_GRAYSCALE == 1

static inline void m7_GetPlanes(void) {
	Planes[0] = (unsigned char *)GrayDBufGetHiddenPlane (DARK_PLANE);
	Planes[1] = (unsigned char *)GrayDBufGetHiddenPlane (LIGHT_PLANE);
	
	GrayDBufToggle();

	Planes[2] = (unsigned char *)GrayDBufGetHiddenPlane (DARK_PLANE);
	Planes[3] = (unsigned char *)GrayDBufGetHiddenPlane (LIGHT_PLANE);

	GrayDBufToggle();
}

void m7_GrayEnd(void) {
  GrayOff ();
	Free(Buff);
}
 
void m7_DBufToggle(void) {
	if(Plane) {
		Plane0 = Planes[0];
		Plane1 = Planes[1];
	} else {
		Plane0 = Planes[2];
		Plane1 = Planes[3];
	}
	GrayDBufToggle();
	Plane = 1 - Plane;
}

void m7_GrayInit(void) {
	Buff = (unsigned char *)Malloc(GRAYDBUFFER_SIZE);
	memset(Buff, 0, GRAYDBUFFER_SIZE);
	if(!GrayOn ()) Exit(1);
	GrayDBufInit (Buff);
	m7_GetPlanes();
	m7_DBufToggle();
}

#if ENABLE_LARGE_MAPS == 2

void m7_SetMap(ExtraMap * m) {
	MapData = m->map;
	MapTiles = m->maptiles;
	DimX = m->dimX;
	DimY = m->dimY;
	TilesOffset = TILES_SIZE * TILES_SIZE;
}

#else

void m7_SetMap(Map * m) {
	MapData = m->map;
	Map0 = m->map0;
	Map1 = m->map1;
	DimX = m->dimX;
	DimY = m->dimY;
}

#endif


void m7_SetSky(unsigned char *sky0, unsigned char *sky1) {
	Sky0 = sky0;
	Sky1 = sky1;
}

#else // no grayscale

#if ENABLE_LARGE_MAPS == 2

void m7_SetMap(ExtraMap * m) {
	MapData = m->map;
	MapTiles = m->maptiles;
	DimX = m->dimX;
	DimY = m->dimY;
	TilesOffset = m->tiles->tilesWidth * m->tiles->tilesHeight << 3;
}

#else

void m7_SetMap(Map * m) {
	MapData = m->map;
	Map0 = m->map0;
	DimX = m->dimX;
	DimY = m->dimY;
}

#endif

void m7_SetSky(unsigned char *sky) {
	Sky0 = sky;
}

#endif
