// C Source File
// Created 20/04/2005; 14:01:04


#include <tigcclib.h>
#include "uncompress.h"

const unsigned char ZMAP_TAG[] = {'\0', 'Z', 'M', 'A', 'P', '\0', OTH_TAG};

// Main Function
void _main(void)
{
	char inputfilename[9];
	char outputfilename[9];
	unsigned short size;
	unsigned char * data;
	unsigned char * dataComp;
	SYM_ENTRY *sym ;
  ESI argptr;

  InitArgPtr (argptr);
  if(GetArgType (argptr) != STR_TAG) return;
  strncpy(inputfilename, GetStrnArg (argptr), 8);
  inputfilename[8] = '\0';
  if(GetArgType (argptr) != STR_TAG) return;
  strncpy(outputfilename, GetStrnArg (argptr), 8);
  outputfilename[8] = '\0';

	sym = SymFindPtr(SYMSTR(inputfilename),0);
	if(!sym) return;
	HANDLE inputH = sym->handle;
	dataComp = HeapDeref(sym->handle);
	size = *(short *)(dataComp) - 7;
	dataComp += 2;
	if(memcmp(ZMAP_TAG, dataComp + size, 7)) return;

	sym = DerefSym(SymAdd(SYMSTR(outputfilename)));
	if(!sym) return;

	HeapLock(inputH);
	data = uncompress(dataComp, &size);
	data = (unsigned char *)realloc(data, size + 6);
	HeapUnlock(inputH);
	data -= 2;
	sym->handle=*(unsigned short *)data;
	*(unsigned short*)data = size + 6;
	HeapUnlock(sym->handle);
	
	data += size+2;
	*(unsigned char *)(data++)=0;
	*(unsigned char *)(data++)='M';
	*(unsigned char *)(data++)='A';
	*(unsigned char *)(data++)='P';
	*(unsigned char *)(data++)=0;
	*(unsigned char *)(data++)=OTH_TAG;
}
